/* Part of the MUST Project, under BSD-3-Clause License
 * See https://hpc.rwth-aachen.de/must/LICENSE for license information.
 * SPDX-License-Identifier: BSD-3-Clause
 */

/**
 * @file MustTypes.h
 *       @see MustTypes.
 *
 *  @date 20.05.2011
 *  @author Joachim Protze
 */

#include <stdint.h>

#ifndef MUSTTYPES_H
#define MUSTTYPES_H

/**
  * Type used for logical timestamps.
  */
typedef unsigned long MustLTimeStamp;

/**
 * Datatype used for MPI communicator handles.
 */
// TODO: think about negative values (especially for lb!) 
//           <-/-> MPI-2.2, 2.5.6 !!!

typedef int64_t MustAddressType;
//typedef long MustAddressType;
//typedef int64_t MustLBType;

/**
 * Datatype used for MPI request handles.
 */
typedef uint64_t MustRequestType;

/**
 * Datatype used for MPI datatype handles.
 */
typedef uint64_t MustDatatypeType;

/**
 * Datatype used for MPI operation handles.
 */
typedef uint64_t MustOpType;

/**
 * Datatype used for MPI key-value handles.
 */
typedef int MustKeyvalType;

/**
 * Datatype used for MPI communicator handles.
 */
typedef uint64_t MustCommType;

/**
 * Datatype used to represent MPI group handles.
 */
typedef uint64_t MustGroupType;

/**
 * Datatype used to represent MPI error handles.
 */
typedef uint64_t MustErrType;

/**
 * Datatype used to represent MPI error handles.
 */
typedef uint64_t MustRemoteIdType;

#endif /*MUSTTYPES_H*/
